/* $Id: hammer.java,v 1.6 2012/01/20 06:28:24 mit Exp $
/* hammer.java v0.1 */
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.text.DecimalFormat;

public class hammer extends Applet implements AdjustmentListener
{
    static final int Partial = 22;
    static final int FONT = 12;
    private Scrollbar scWide;
    private Panel P;
    private Label lWide;

    int W, H;
    DecimalFormat df1;
    private static final long serialVersionUID = 1L;

    public void init() {
        setFont(new Font("SansSerif", Font.PLAIN, FONT));
        setBackground(Color.lightGray);
        setLayout(new BorderLayout());
        df1 = new DecimalFormat("#0.0#");

	P = new Panel();
        P.setLayout(new GridLayout(1,2,0,0));

        scWide = new Scrollbar(Scrollbar.HORIZONTAL, 1, 1, 1, 101);
        P.add(scWide);
        scWide.addAdjustmentListener(this);

	lWide = new Label(" Wide: ___");
        P.add(lWide);

        add(P, "South");
    }

    public void start() {
	W = getCanvasD().width;
        H = getCanvasD().height;
    }
    public Dimension getCanvasD() {
        Dimension dp = P.getSize();
        Dimension da = getSize();
        int cw = da.width;
        int ch = da.height-dp.height;
        Dimension can = new Dimension(cw, ch);

        return can;
    }
    public String dform(double n) {
        return df1.format((float)n);
    }
    public void adjustmentValueChanged(AdjustmentEvent e) {
        repaint();
    }
    public double calcHammer(double x, int par) {
	return 1.0-Math.cos(par*Math.PI*x*0.1);
    }
    //
    public void update(Graphics g) {
        paint(g);
    }
    public void paint(Graphics g) {
        g.setColor(Color.black);
        g.fillRect(0, 0, W, H);

	double xb = scWide.getValue()/10.0;
	int gain = 90;               // ⤵Ψ 
	double dx = W/(double)Partial;
	int wd = (int)(dx/2);        // 
	int sf = wd/2;               // ե
	int Sft = FONT*3;            // 
	int Base = H-Sft;            // 

	dispLine(g, Base);
	dispHLine(g, Base, gain);
	set_label(xb);

	int xx;
	double yy;
	for (int i = 0; i <= Partial; i++) {
	    yy = calcHammer(xb, i)*gain;
	    xx = (int)(dx*i);

	    //System.out.println(i+": "+(float)yy);

	    g.setColor(Color.green);
	    g.fillRect(xx, (int)(Base-yy), wd, (int)yy);

	    if (i % 5 == 0 & i != 0 | i == 1) {
		g.setColor(Color.white);
		g.drawString(i+"", xx, Base+FONT*2);

		g.setColor(Color.lightGray);
		g.drawLine(xx+sf, Base, xx+sf, Base+FONT);
	    } else {
		g.setColor(Color.lightGray);
		g.drawLine(xx+sf, Base, xx+sf, Base+FONT/2);
	    }
	}
    }
    public void set_label(double xb) {
	lWide.setText(" Wide: "+dform(xb/10));
    }
    public void dispLine(Graphics g, int base) {
	g.setColor(Color.blue);
	g.drawLine(0, base, W, base);
    }
    public void dispHLine(Graphics g, int base, int gain) {
	double iv, val = 0.2;
	int yy;
	for (int i = 0; i < 14; i++) {
	    iv = i*val;
	    yy = (int)(base-iv*gain);

	    g.setColor(Color.gray);
	    g.drawLine(0, yy, W, yy);

	    g.setColor(Color.lightGray);
	    g.drawString(dform(iv), W-25, yy);
	}
    }
}